//Global to vertex & fragment shader. Consists of 3 floats.
varying vec3 normal;

void main()
{
	//Declarations
	float intensity;
	vec4 color;
	vec3 n = normalize(normal);
	
	//Rather complex maths, the shadow intensity is calculated with this.
	intensity = dot(vec3(gl_LightSource[0].position),n);
	
	//Set output color to the diffuse material of the front side of the current fragment.
	color = gl_FrontMaterial.diffuse;
	
	//Preprocessors.
	#define A 0.9
	#define B 0.5+sin(normal.x*5.0)*cos(normal.y*5.0)*0.4
	
	//Step-wise shadow intensity checking... relatively random effect. I think it looks cool, though :P
	if(intensity < 0.9)
		color *= vec4(A,A,B,1.0);
	if(intensity < 0.6)
		color *= vec4(A,B,B,1.0);
	if(intensity < 0.4)
		color *= vec4(B,B,A,1.0);
	if(intensity < 0.2)
		color *= vec4(B,A,B,1.0);
	
	//Assign color
	gl_FragColor = color;
} 